VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClipB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim c_pasting As Boolean
Dim undoch As Changes
Dim parent As frmMain

Private Sub Class_Initilialize()
    'by default not pasting
    c_pasting = False
End Sub

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Public Property Get pasting() As Boolean
    pasting = c_pasting
End Property
Public Property Let pasting(newpasting As Boolean)
    c_pasting = newpasting
End Property

Function getTile(X As Integer, Y As Integer) As Integer
    getTile = SharedVar.clipdata(X, Y)
End Function

Sub CutOrCopy(cutmode As Boolean, startx As Integer, starty As Integer, endx As Integer, endy As Integer)
    'Copies the selected tiles to the clipdata array
    'If cutmode is selected, all source tiles will
    'be deleted in the process
    
    If parent.sel.selstate = append Then
    
        If cutmode Then
            parent.undoredo.ResetRedo
            Set undoch = New Changes
            Call parent.sel.StopSelecting
        End If
        
        SharedVar.clipdatasizex = Abs(startx - endx) + 1
        SharedVar.clipdatasizey = Abs(starty - endy) + 1
        ReDim SharedVar.clipdata(SharedVar.clipdatasizex, SharedVar.clipdatasizey)
        Dim i As Integer
        Dim j As Integer
        
        For j = starty To endy
            For i = startx To endx
                SharedVar.clipdata(i - startx, j - starty) = parent.getTile(i, j)
                
                If cutmode Then
                    'once copied to the string, remove it
                    Call parent.setTile(i, j, 0, undoch)
                    Call parent.UpdateLevelTile(i, j, False)
                End If
            Next
        Next
        
        If cutmode Then Call parent.undoredo.AddToUndo(undoch)
        
        parent.UpdatePreview
        
        'flag that the clipboard contains data
        SharedVar.clipHasData = True
    End If
    
End Sub


Sub Paste(Optional PasteX As Integer = 0, Optional PasteY As Integer = 0)
    'Dont paste if not necessary
    If Not SharedVar.clipHasData Then
        Exit Sub
    End If
    
    'All we have to do is draw the selection
    Call redraw(0, 0)
End Sub

Sub TexTToMap(text() As Integer, Width As Integer, Height As Integer)
 ' as the selection is not an apart picture, we use the same routine as with pasting
    Call parent.sel.StopSelecting
    c_pasting = True
' note that this method sucks by far, but a solution is a solution, if the selection is ever
' gonna get an own layer, then we can use that one, instead of 'tricking' dcme and handling this
' as a input from clipboard

    SharedVar.clipdata = text
    SharedVar.clipdatasizex = Width
    SharedVar.clipdatasizey = Height

    Call redraw(0, 0)
End Sub

Sub PicToMap(pic() As Integer, Width As Integer, Height As Integer)
 ' as the selection is not an apart picture, we use the same routine as with pasting
    Call parent.sel.StopSelecting
    c_pasting = True
' note that this method sucks by far, but a solution is a solution, if the selection is ever
' gonna get an own layer, then we can use that one, instead of 'tricking' dcme and handling this
' as a input from clipboard

    SharedVar.clipdata = pic
    SharedVar.clipdatasizex = Width
    SharedVar.clipdatasizey = Height

    Call redraw(0, 0)
End Sub

Sub redraw(PasteX As Integer, PasteY As Integer)
    Call parent.sel.StopSelecting
    c_pasting = True
        
    parent.picclipboard.Width = SharedVar.clipdatasizex * (TileW * parent.magnifier.Zoom)
    parent.picclipboard.Height = SharedVar.clipdatasizey * (TileH * parent.magnifier.Zoom)
    
    If parent.picclipboard.Width > parent.picpreview.Width Then
        parent.picclipboard.Width = parent.picpreview.Width
    End If
    
    If parent.picclipboard.Height > parent.picpreview.Height Then
        parent.picclipboard.Height = parent.picpreview.Height
    End If
    
    parent.picclipboard.Cls
    Dim i As Integer
    Dim j As Integer
    
    For j = 0 To SharedVar.clipdatasizey - 1
        For i = 0 To SharedVar.clipdatasizex - 1
            If parent.magnifier.UsingPixels Then
                If parent.getTile(i, j) <> 0 Then
                    Call SetPixel(parent.picclipboard.HDC, i, j, TilePixelColor(SharedVar.clipdata(i, j)))
                End If
            Else
                If SharedVar.clipdata(i, j) = 217 Then
                    SetStretchBltMode parent.picclipboard.HDC, HALFTONE
                    StretchBlt parent.picclipboard.HDC, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), 2 * (TileW * parent.magnifier.Zoom), 2 * (TileH * parent.magnifier.Zoom), frmGeneral.picspecial.HDC, 16, 0, 2 * TileW, 2 * TileH, vbSrcCopy
                ElseIf SharedVar.clipdata(i, j) = 219 Then
                    SetStretchBltMode parent.picclipboard.HDC, HALFTONE
                    StretchBlt parent.picclipboard.HDC, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), 6 * (TileW * parent.magnifier.Zoom), 6 * (TileH * parent.magnifier.Zoom), frmGeneral.picspecial.HDC, 128, 0, 6 * TileW, 6 * TileH, vbSrcCopy
                ElseIf SharedVar.clipdata(i, j) = 220 Then
                    SetStretchBltMode parent.picclipboard.HDC, HALFTONE
                    StretchBlt parent.picclipboard.HDC, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), 5 * (TileW * parent.magnifier.Zoom), 5 * (TileH * parent.magnifier.Zoom), frmGeneral.picspecial.HDC, 48, 0, 5 * TileW, 5 * TileH, vbSrcCopy
                ElseIf SharedVar.clipdata(i, j) <> 0 Then
                    BitBlt parent.picclipboard.HDC, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.piczoomtileset.HDC, ((SharedVar.clipdata(i, j) - 1) Mod 19) * (TileW * parent.magnifier.Zoom), Int((SharedVar.clipdata(i, j) - 1) / 19) * (TileH * parent.magnifier.Zoom), vbSrcCopy
                Else
                    parent.picempty.Width = TileW * parent.magnifier.Zoom
                    parent.picempty.Height = TileH * parent.magnifier.Zoom
                    BitBlt parent.picclipboard.HDC, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.picempty.HDC, 0, 0, vbSrcCopy
                End If
            End If

        Next
    Next
    parent.picclipboard.refresh
    
    parent.shpdraw.Left = PasteX
    parent.shpdraw.Top = PasteY
    parent.shpdraw.Width = parent.picclipboard.Width
    parent.shpdraw.Height = parent.picclipboard.Height
    parent.shpdraw.Visible = True
    
    Dim seltilestartx As Integer
    Dim seltileendx As Integer
    Dim seltilestarty As Integer
    Dim seltileendy As Integer
    seltilestartx = (Int((parent.hScr.value + parent.shpdraw.Left) / (TileW * parent.magnifier.Zoom)))
    seltilestarty = (Int((parent.vscr.value + parent.shpdraw.Top) / (TileH * parent.magnifier.Zoom)))
    seltileendx = seltilestartx + (parent.shpdraw.Width / (TileW * parent.magnifier.Zoom)) - 1
    seltileendy = seltilestarty + (parent.shpdraw.Height / (TileH * parent.magnifier.Zoom)) - 1
    
    Call parent.sel.SetSelRegionForPasting(seltilestartx, seltilestarty, seltileendx, seltileendy, False)
    
    parent.UpdatePreview
    BitBlt parent.picpreview.HDC, parent.shpdraw.Left, parent.shpdraw.Top, parent.shpdraw.Width, parent.shpdraw.Height, parent.picclipboard.HDC, 0, 0, vbSrcCopy
    parent.picpreview.refresh
    
End Sub

Function GetInitialCoordX() As Integer
    If parent.magnifier.UsingPixels = True Then
        GetInitialCoordX = parent.hScr.value + parent.shpdraw.Left
    Else
        GetInitialCoordX = (Int(((parent.hScr.value + parent.shpdraw.Left + 2)) / (TileW * parent.magnifier.Zoom)))
    End If
End Function
Function GetInitialCoordY() As Integer
    If parent.magnifier.UsingPixels = True Then
        GetInitialCoordY = parent.vscr.value + parent.shpdraw.Top
    Else
        GetInitialCoordY = (Int(((parent.vscr.value + parent.shpdraw.Top + 2)) / (TileH * parent.magnifier.Zoom)))
    End If
End Function
